﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Hotline.BatchTask
{
    public interface IApptaskDomainService
    {
        /// <summary>
        /// 新增任务
        /// </summary>
        Task<string> AddAsync(Apptask apptask, CancellationToken cancellation);

        /// <summary>
        /// 查询任务进度
        /// </summary>
        /// <returns></returns>
        Task<> QueryProgressAsync(string taskId, CancellationToken cancellation);

        /// <summary>
        /// 终止任务
        /// </summary>
        /// <param name="taskId"></param>
        /// <param name="cancellation"></param>
        /// <returns></returns>
        Task TerminalTaskAsync(string taskId, CancellationToken cancellation);

        /*job request*/
        Task<ApptaskItem> GetNextAsync(CancellationToken cancellation);

        Task ExecuteAsync(IApptaskExecutor executor, CancellationToken cancellation);
    }

    public class ApptaskDomainService : IApptaskDomainService
    {

    }
}
